/*
 * Copyright (C) 2017 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.modaccess;

import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.MultiPoint;
import org.locationtech.jts.geom.Point;
import java.awt.HeadlessException;
import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import org.geotools.data.DataStore;
import org.opengis.feature.type.AttributeType;
import org.thema.data.IOFeature;

/**
 *
 * @author Gilles Vuidel
 */
public class BuildTimeNetworkDialog extends javax.swing.JDialog {

    public boolean isOk = false;
    public String name;
    public File stations;
    public String idField;
    public File dir;

    /** Creates new form LoadNetworkDialog */
    public BuildTimeNetworkDialog(java.awt.Frame parent) {
        super(parent, true);
        initComponents();
        setLocationRelativeTo(parent);
        getRootPane().setDefaultButton(okButton);
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        nodeSelectFilePanel = new org.thema.common.swing.SelectFilePanel();
        idNodeComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        dirSelectFilePanel = new org.thema.common.swing.SelectFilePanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/modaccess/Bundle"); // NOI18N
        setTitle(bundle.getString("BuildTimeNetworkDialog.title")); // NOI18N

        okButton.setText(bundle.getString("BuildTimeNetworkDialog.okButton.text")); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("BuildTimeNetworkDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        nodeSelectFilePanel.setDescription(bundle.getString("BuildTimeNetworkDialog.nodeSelectFilePanel.description")); // NOI18N
        nodeSelectFilePanel.setFileDesc(bundle.getString("BuildTimeNetworkDialog.nodeSelectFilePanel.fileDesc")); // NOI18N
        nodeSelectFilePanel.setFileExts(bundle.getString("BuildTimeNetworkDialog.nodeSelectFilePanel.fileExts")); // NOI18N
        nodeSelectFilePanel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nodeSelectFilePanelActionPerformed(evt);
            }
        });

        jLabel1.setText(bundle.getString("BuildTimeNetworkDialog.jLabel1.text")); // NOI18N

        jLabel4.setText(bundle.getString("BuildTimeNetworkDialog.jLabel4.text")); // NOI18N

        dirSelectFilePanel.setDescription(bundle.getString("BuildTimeNetworkDialog.dirSelectFilePanel.description")); // NOI18N
        dirSelectFilePanel.setDirectoryOnly(true);
        dirSelectFilePanel.setFileDesc(bundle.getString("BuildTimeNetworkDialog.dirSelectFilePanel.fileDesc")); // NOI18N
        dirSelectFilePanel.setFileExts(bundle.getString("BuildTimeNetworkDialog.dirSelectFilePanel.fileExts")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(12, 12, 12)
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(idNodeComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 137, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(jLabel4)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(nameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(nodeSelectFilePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(okButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(cancelButton))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, dirSelectFilePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE))
                        .addContainerGap())))
        );

        layout.linkSize(new java.awt.Component[] {cancelButton, okButton}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(nameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(nodeSelectFilePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(idNodeComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1))
                .add(18, 18, 18)
                .add(dirSelectFilePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 30, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cancelButton)
                    .add(okButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        name = nameTextField.getText();
        stations = nodeSelectFilePanel.getSelectedFile();
        idField = idNodeComboBox.getSelectedItem().toString();
        dir = dirSelectFilePanel.getSelectedFile();
        isOk = true;
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void nodeSelectFilePanelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nodeSelectFilePanelActionPerformed
        try {
            DefaultComboBoxModel idModel = new DefaultComboBoxModel();

            File f = nodeSelectFilePanel.getSelectedFile();
            DataStore dataStore = IOFeature.getDataStore(f);
            List<AttributeType> attrs = dataStore.getSchema(dataStore.getTypeNames()[0]).getTypes();
            for(AttributeType attr : attrs) {
                if(!Geometry.class.isAssignableFrom(attr.getBinding())) {
                    idModel.addElement(attr.getName().getLocalPart());
                } else
                    if(!Point.class.isAssignableFrom(attr.getBinding())) {
                        if(!MultiPoint.class.isAssignableFrom(attr.getBinding())) {
                            JOptionPane.showMessageDialog(this, "Shapes must be point.", "Error", JOptionPane.ERROR_MESSAGE);
                            return;
                        } else {
                            JOptionPane.showMessageDialog(this, "Shapes are multipoint.", "Warning", JOptionPane.WARNING_MESSAGE);
                        }
                }
            }

            idNodeComboBox.setModel(idModel);

        } catch (HeadlessException | IOException ex) {
            Logger.getLogger(BuildTimeNetworkDialog.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading the file.\n Details : " + ex.getLocalizedMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_nodeSelectFilePanelActionPerformed



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private org.thema.common.swing.SelectFilePanel dirSelectFilePanel;
    private javax.swing.JComboBox idNodeComboBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField nameTextField;
    private org.thema.common.swing.SelectFilePanel nodeSelectFilePanel;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

}
